#ifndef VY_VK_GPU_H
#define VY_VK_GPU_H

#include <volk/volk.h>

typedef struct {
    VkInstance instance;
    VkDebugUtilsMessengerEXT messenger;
    VkAllocationCallbacks *alloc_cb;
    VkPhysicalDevice phys_device;
    VkDevice device;
    VkSurfaceKHR surface;
    VkQueue graphics_queue;
    VkQueue compute_queue;
    VkQueue present_queue;

    VkPhysicalDeviceDescriptorIndexingProperties descriptor_indexing_props;
    VkPhysicalDeviceProperties phys_device_props;
} vy_vk_gpu;

#ifndef VY_VK_DONT_DEFINE_GPU_GLOBAL
extern vy_vk_gpu g_gpu;
#endif

#endif
